{this unit uses the tmultiimage component which must be added, select
 Options/Install Components/Add and add reg_image.pas}


unit Uimage;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl, Reg_imag, VBXCtrl, Switch, Spin,
  Buttons, UFullscr, Menus, Uabout;

type
  TForm1 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    MultiImage1: TMultiImage;
    Sstretch: TBiSwitch;
    Label1: TLabel;
    Label2: TLabel;
    SaveAs: TBiSwitch;
    Label3: TLabel;
    Label4: TLabel;
    SaveDialog1: TSaveDialog;
    SaveButton: TBitBtn;
    QualitySpin: TSpinEdit;
    Smoothspin: TSpinEdit;
    QualityLabel: TLabel;
    SmoothLabel: TLabel;
    GroupBox1: TGroupBox;
    res4: TRadioButton;
    res24: TRadioButton;
    res8: TRadioButton;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    DitherOneNo: TRadioButton;
    DitherOneYes: TRadioButton;
    DitherTwoNo: TRadioButton;
    DitherTwoYes: TRadioButton;
    Dither24Bit: TRadioButton;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    O1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    E1: TMenuItem;
    A1: TMenuItem;
    OpenDialog1: TOpenDialog;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure SstretchOnOff(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure resClick(Sender: TObject);
    procedure DitherClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure MultiImage1Click(Sender: TObject);
    procedure E1Click(Sender: TObject);
    procedure O1Click(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure setsavevisible(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    oldsavefiles : TstringList;
    oldreadfiles : TstringList;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{update the drive of DirectoryListBox1 with the drive of DriveComboBox1}
procedure TForm1.DriveComboBox1Change(Sender: TObject);
begin
  DirectoryListBox1.Drive := DriveComboBox1.Drive;
end;

{update the directory of FileListBox1 with the directory of FileListBox1}
procedure TForm1.DirectoryListBox1Change(Sender: TObject);
begin
       FileListBox1.Directory := DirectoryListBox1.Directory;
end;

{Display the image of the FileListBox1.filename}
procedure TForm1.FileListBox1Change(Sender: TObject);
begin
 {set hourglass cursor}
  screen.cursor:=crHourGlass;

 {display an image using the vcl}
  MultiImage1.imagename:=FileListBox1.filename;

 {add filename to the history list of the open dialog}
  oldreadfiles.add(FileListBox1.filename);

 {copy the stringlist to the historylist}
  OpenDialog1.historylist:=oldreadfiles;

  {set default cursor}
  screen.cursor:=crDefault;
end;


{set strech mode}
procedure TForm1.SstretchOnOff(Sender: TObject);
begin
  MultiImage1.stretch:=Sstretch.Pon;
end;

{hide or show jpeg save options}
procedure TForm1.setsavevisible(Sender: TObject);
begin
    QualitySpin.visible:=SaveAs.Pon;
    Smoothspin.visible:=SaveAs.Pon;
    QualityLabel.visible:=SaveAs.Pon;
    SmoothLabel.visible:=SaveAs.Pon;
end;

{what we do on create}
procedure TForm1.FormCreate(Sender: TObject);
begin
    {set the value of the QualitySpin to the value of JPegSaveQuality}
    QualitySpin.value:=MultiImage1.JPegSaveQuality;

    {set the value of the Smoothspin to the value of JPegSaveSmooh}
    Smoothspin.value:=MultiImage1.JPegSaveSmooh;

    {show the save options depending on the saveas switch pon state}
    setsavevisible(sender);

    {create temporary history stringlists}
    oldsavefiles := TstringList.create;
    oldreadfiles := TstringList.create;
end;

{Set the jpeg resolution to either 16, 256 or true color in the vcl}
procedure TForm1.resClick(Sender: TObject);
begin
 {set jpeg show resolution to 4 bit 16 color}
 if res4.checked  then MultiImage1.JPegResolution:=4;

 {set jpeg show resolution to 8 bit 256 color}
 if res8.checked  then MultiImage1.JPegResolution:=8;

 {set jpeg show resolution to 24 bit true color}
 if res24.checked then MultiImage1.JPegResolution:=24;
end;


{Set the jpeg dither in the vcl}
procedure TForm1.DitherClick(Sender: TObject);
begin
  {set the jpeg show dither to none (best choice for true color 24 bit}
  if Dither24Bit.checked  then MultiImage1.JPegDither:=0;

  {set the jpeg show dither to one pass none}
  if DitherOneNo.checked  then MultiImage1.JPegDither:=1;

  {set the jpeg show dither to one pass dithered (best choice for 16 colors)}
  if DitherOneYes.checked  then MultiImage1.JPegDither:=2;

  {set the jpeg show dither to one pass none}
  if DitherTwoNo.checked  then MultiImage1.JPegDither:=3;

  {set the jpeg show dither to two pass dithered (best choice for 256 colors)}
  if DitherTwoYes.checked  then MultiImage1.JPegDither:=4;
end;

{save a jpeg}
procedure TForm1.SaveButtonClick(Sender: TObject);
begin
 {open save dialog}
 if SaveDialog1.execute then begin

 {set hourglass cursor}
  screen.cursor:=crHourGlass;

  {save it if the extension is jpg}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.JPG' then
    MultiImage1.SaveAsJpg(SaveDialog1.FileName);

  {save it if the extension is bmp}
  if UpperCase(ExtractFileExt(SaveDialog1.Filename)) =  '.BMP' then
    MultiImage1.Picture.SaveToFile(SaveDialog1.FileName);

 {add filename to the history list of the save dialog}
  oldSavefiles.add(SaveDialog1.filename);

 {copy the stringlist to the historylist}
  SaveDialog1.historylist:=oldSavefiles;

 {set default cursor}
  screen.cursor:=crDefault;

  {update the filelist box sothat the file saved shows up}
  FileListBox1.Update;
 end;
end;

{show fullscreen}
procedure TForm1.MultiImage1Click(Sender: TObject);
begin
  {copy image to fullscreen image}
  FullSlide.MultiImage1.Picture.Graphic:=MultiImage1.Picture.Graphic;
  {show the image fulscreen}
  FullSlide.showmodal;
end;

{exit the program}
procedure TForm1.E1Click(Sender: TObject);
begin
 close;
end;

{open a image using the open dialog}
procedure TForm1.O1Click(Sender: TObject);
begin
  if OpenDialog1.execute then begin

   {set hourglass cursor}
    screen.cursor:=crHourGlass;

    {display an image using the vcl}
    MultiImage1.imagename:=OpenDialog1.filename;

   {add filename to the history list of the open dialog}
    oldreadfiles.add(OpenDialog1.filename);

   {copy the stringlist to the historylist}
    OpenDialog1.historylist:=oldreadfiles;

   {set default cursor}
    screen.cursor:=crDefault;
  end;
end;

{about box}
procedure TForm1.A1Click(Sender: TObject);
begin
{Copy the image to the image of he about box}
 AboutBox.MultiImage1.Picture.Graphic:=MultiImage1.Picture.Graphic;
{show the about box}
 AboutBox.showmodal;
end;

{what to do on exit}
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   {release memory of the stringlist boxes}
    oldsavefiles.free;
    oldreadfiles.free;
end;

end.
